SystemOrganization addCategory: #ConfigurationOfPhantom!

Object subclass: #ConfigurationOfPhantom
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPhantom'!

!ConfigurationOfPhantom classSide methodsFor: 'development support' stamp: 'DanielGaldames 4/14/2011 13:00'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPhantom classSide methodsFor: 'private' stamp: 'DanielGaldames 4/14/2011 13:00'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPhantom classSide methodsFor: 'private' stamp: 'DanielGaldames 4/14/2011 13:00'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPhantom classSide methodsFor: 'private' stamp: 'DanielGaldames 4/14/2011 13:00'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPhantom classSide methodsFor: 'metacello tool support' stamp: 'DanielGaldames 4/14/2011 13:00'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPhantom classSide methodsFor: 'loading' stamp: 'DanielGaldames 4/14/2011 13:00'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPhantom classSide methodsFor: 'loading' stamp: 'DanielGaldames 4/14/2011 13:00'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPhantom classSide methodsFor: 'loading' stamp: 'DanielGaldames 4/14/2011 13:00'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPhantom classSide methodsFor: 'accessing' stamp: 'DanielGaldames 4/14/2011 13:00'!
project

	^self new project! !

!ConfigurationOfPhantom classSide methodsFor: 'development support' stamp: 'DanielGaldames 4/14/2011 13:00'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPhantom methodsFor: 'as yet unclassified' stamp: 'dgg 1/26/2012 15:29'!
baseline10: spec
	<version: '1.0-baseline'>
		spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Phantom'.

		spec
			package: 'Phantom-Core' with: [spec requires: #('PetitParser' 'Phantom-PrecedenceGraph' 'MethodWrappers')];
			package: 'PetitParser' with: [spec repository: 'http://source.lukas-renggli.ch/petit'];
			package: 'MethodWrappers' with: [spec repository: 'http://www.squeaksource.com/ObjectMetaTools'];
			package: 'Phantom-PrecedenceGraph';
			package: 'Phantom-Tests' with: [ spec requires: #('Phantom-Core')];
			package: 'Phantom-Examples' with: [ spec requires: #('Phantom-Core')];
			package: 'Phantom-PrecedenceGraphTests' with: [ spec requires: #('Phantom-PrecedenceGraph')].
		
		spec
			group: 'default' with: #('Phantom-Core' 'Phantom-Examples');
			group: 'Core' with: #('Phantom-Core');
			group: 'Tests' with: #('Phantom-Tests' 'Phantom-PrecedenceGraphTests').
		].
	
	spec for: #'pharo1.3.x' do: [
		spec blessing: #baseline.

		spec
			package: 'Phantom-Core' with: [spec requires: #('AST-Core')];
			package: 'AST-Core' with: [spec repository: 'http://www.squeaksource.com/rb']].
	
	spec for: #'pharo1.4.x' do: [
		spec blessing: #baseline.
		
		spec
			package: 'MethodWrappers' with: [spec repository: 'http://www.squeaksource.com/Phantom']]
! !

!ConfigurationOfPhantom methodsFor: 'symbolic versions' stamp: 'dgg 9/18/2011 17:17'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.2.2'.
! !

!ConfigurationOfPhantom methodsFor: 'accessing' stamp: 'DanielGaldames 4/14/2011 13:00'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPhantom methodsFor: 'symbolic versions' stamp: 'dgg 9/18/2011 17:17'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.2.1'.
! !

!ConfigurationOfPhantom methodsFor: 'as yet unclassified' stamp: 'DanielGaldames 4/22/2011 19:17'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec for: #common do: [
		spec blessing: #release.
		spec package: 'PetitParser' with: 'PetitParser-lr.211'.
		spec package: 'AST-Core' with: 'AST-Core-lr.87'.
		spec package: 'MethodWrappers' with: 'MethodWrappers-MarianoMartinezPeck.6'.
		spec package: 'Phantom-Core' with: 'Phantom-Core-DanielGaldames.1'.
		spec package: 'Phantom-Tests' with: 'Phantom-Tests-DanielGaldames.6'.
		spec package: 'Phantom-Examples' with: 'Phantom-Examples-DanielGaldames.5'.
		spec package: 'Phantom-PrecedenceGraph' with: 'Phantom-PrecedenceGraph-DanielGaldames.1'.
		spec package: 'Phantom-PrecedenceGraphTests' with: 'Phantom-PrecedenceGraphTests-DanielGaldames.1'.]! !

!ConfigurationOfPhantom methodsFor: 'versions' stamp: 'dgg 5/4/2011 12:26'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'advices are build on install for the method wrapper
1.1 (): advice manipulation
1.1 (): recategorization adviceIndex on context
1.1 (): 
	- change advices to advice.
	- fix bug in change order of an advice in other advice
- added inheritance precedence
- added tests'.
		spec author: 'DanielGaldames'.
		spec timestamp: '4/19/2011 16:42'.
		spec 
			package: 'PetitParser' with: 'PetitParser-lr.211';
			package: 'AST-Core' with: 'AST-Core-lr.87';
			package: 'MethodWrappers' with: 'MethodWrappers-MarianoMartinezPeck.6';
			package: 'Phantom-Core' with: 'Phantom-Core-dgg.24';
			package: 'Phantom-Tests' with: 'Phantom-Tests-dgg.19';
			package: 'Phantom-Examples' with: 'Phantom-Examples-DanielGaldames.5';
			package: 'Phantom-PrecedenceGraph' with: 'Phantom-PrecedenceGraph-DanielGaldames.1';
			package: 'Phantom-PrecedenceGraphTests' with: 'Phantom-PrecedenceGraphTests-DanielGaldames.1'. ].
! !

!ConfigurationOfPhantom methodsFor: 'versions' stamp: 'dgg 12/1/2011 12:24'!
version121: spec
	<version: '1.2.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: '1.2.1: devel
1.2.1 ():'.
		spec author: 'dgg'.
		spec timestamp: '9/18/2011 17:14'.
		spec 
			package: 'PetitParser' with: 'PetitParser-lr.211';
			package: 'AST-Core' with: 'AST-Core-lr.87';
			package: 'MethodWrappers' with: 'MethodWrappers-MarianoMartinezPeck.6';
			package: 'Phantom-Core' with: 'Phantom-Core-dgg.59';
			package: 'Phantom-Tests' with: 'Phantom-Tests-dgg.38';
			package: 'Phantom-Examples' with: 'Phantom-Examples-dgg.12';
			package: 'Phantom-PrecedenceGraph' with: 'Phantom-PrecedenceGraph-dgg.3';
			package: 'Phantom-PrecedenceGraphTests' with: 'Phantom-PrecedenceGraphTests-dgg.2'. ].
! !

!ConfigurationOfPhantom methodsFor: 'versions' stamp: 'dgg 2/20/2012 20:27'!
version122: spec
	<version: '1.2.2' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.2.2 ():
1.2.2 (): - Changed pand: and por: selectors on PhPointcut to & and |
1.2.2 (): - fix a por: in membrane visibility test
1.2.2 (): - changed PhClassModifier to receive a pointcut instead of a class
1.2.2 (): New advice instantiation syntax
1.2.2 (): updated PhAdvice adice: and send:to: to always recive a context 
1.2.2 (): fix strange corruption on some tests
- Pointcut memoization
- Pointcut memoization
- Update the system aspects only if new class or method should be captured
- Added ClassModifiers to new pointcut verification
- fix a bug on receiverParser (* class not working)
- simplify receiverParser parser generation
- added a test for sender exposure on send:to: advice
- fix out of bounds on PhAdviceRunner runNextAdvice
- fix bug on combined ifblock
- notInCflowOf:  
* need more tests
- fix a bug getting the current sender
- added methods to disable automatic update
- fix bug on UpdateEnabled variable not initialized
- added a test for sender exposure on send:to: advice
- fix on PhAspectWeaver UpdateEnabled initialization
- modification of PhAroundAdviceRunner behavior'.
		spec author: 'dgg'.
		spec timestamp: '2/20/2012 20:27'.
		spec 
			package: 'PetitParser' with: 'PetitParser-lr.211';
			package: 'MethodWrappers' with: 'MethodWrappers-MarianoMartinezPeck.6';
			package: 'Phantom-Core' with: 'Phantom-Core-dgg.81';
			package: 'Phantom-Tests' with: 'Phantom-Tests-dgg.53';
			package: 'Phantom-Examples' with: 'Phantom-Examples-dgg.13';
			package: 'Phantom-PrecedenceGraph' with: 'Phantom-PrecedenceGraph-dgg.3';
			package: 'Phantom-PrecedenceGraphTests' with: 'Phantom-PrecedenceGraphTests-dgg.2'. ].

	spec for: #'pharo1.3.x' do: [
		spec blessing: #'development'.
		spec author: 'dgg'.
		spec timestamp: '1/25/2012 23:32'.
		spec package: 'AST-Core' with: 'AST-Core-lr.87'. ].

	spec for: #'pharo1.4.x' do: [
		spec blessing: #'development'.
		spec author: 'dgg'.
		spec timestamp: '1/25/2012 23:32'.
		spec package: 'MethodWrappers' with: 'MethodWrappers-dgg.7'. ].
! !

!ConfigurationOfPhantom methodsFor: 'versions' stamp: 'dgg 5/15/2011 19:01'!
version12: spec
	<version: '1.2' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.2: devel'.
		spec author: 'dgg'.
		spec timestamp: '5/12/2011 13:32'.
		spec 
			package: 'PetitParser' with: 'PetitParser-lr.211';
			package: 'AST-Core' with: 'AST-Core-lr.87';
			package: 'MethodWrappers' with: 'MethodWrappers-MarianoMartinezPeck.6';
			package: 'Phantom-Core' with: 'Phantom-Core-dgg.34';
			package: 'Phantom-Tests' with: 'Phantom-Tests-dgg.22';
			package: 'Phantom-Examples' with: 'Phantom-Examples-dgg.9';
			package: 'Phantom-PrecedenceGraph' with: 'Phantom-PrecedenceGraph-DanielGaldames.1';
			package: 'Phantom-PrecedenceGraphTests' with: 'Phantom-PrecedenceGraphTests-DanielGaldames.1'. ].
! !
